# Class SendFailedNotification

java.lang.Object
com.sun.nio.sctp.SendFailedNotification

All Implemented Interfaces:
  `Notification`

public abstract class SendFailedNotification extends Object implements Notification
Notification emitted when a send failed notification has been received.

A send failed notification indicates that a message cannot be delivered. Typically, this is because the association has been shutdown with unsent data in the socket output buffer, or in the case of a `SctpMultiChannel` the association failed to setup.

Since:
  1.7

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `SendFailedNotification()`
  Initializes a new instance of this class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract SocketAddress`
  `address()`
  Returns the address.
  `abstract Association`
  `association()`
  Returns the association that this notification is applicable to.
  `abstract ByteBuffer`
  `buffer()`
  Returns the data that was to be sent.
  `abstract int`
  `errorCode()`
  Returns the error code.
  `abstract int`
  `streamNumber()`
  Returns the stream number that the message was to be sent on.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SendFailedNotification

    protected SendFailedNotification()
    Initializes a new instance of this class.

- ## Method Details

  - ### association

    public abstract Association association()
    Returns the association that this notification is applicable to.
    Specified by:
      `association` in interface `Notification`
    Returns:
      The association that failed to send, or `null` if there is no association, that is, the notification follows a AssociationChangeNotification.AssocChangeEvent.CANT_START

  - ### address

    public abstract SocketAddress address()
    Returns the address.
    Returns:
      The peer primary address of the association or the address that the message was sent to

  - ### buffer

    public abstract ByteBuffer buffer()
    Returns the data that was to be sent.
    Returns:
      The user data. The buffers position will be `0` and its limit will be set to the end of the data.

  - ### errorCode

    public abstract int errorCode()
    Returns the error code.

    The errorCode gives the reason why the send failed, and if set, will be a SCTP protocol error code as defined in RFC2960 section 3.3.10

    Returns:
      The error code

  - ### streamNumber

    public abstract int streamNumber()
    Returns the stream number that the message was to be sent on.
    Returns:
      The stream number